Subject: 23.1; sgml-lexical-context on <!-- comments

From: Kevin Ryde <[email-masked]>
Date: Thu, 22 Oct 2009 10:02:31 +1100

In a file foo.html containing

    <!-- foo -->

and in html-mode with point on the "foo", calling `sgml-lexical-context'
returns

    (tag . 1)

where I thought from the docstring of that function it would be

    (comment . 1)

I suppose parse-partial-sexp doesn't quite recognise <!--, or not
without the sgml-specials hack.  I get some joy from the lines below.

2009-10-20  Kevin Ryde  <[email-masked]>

	* textmodes/sgml-mode.el (sgml-lexical-context): Recognise
	comment-start-skip to comment-end-skip as `comment' instead of `tag'.

Index: sgml-mode.el
===================================================================
RCS file: /sources/emacs/emacs/lisp/textmodes/sgml-mode.el,v
retrieving revision 1.143
diff -u -u -r1.143 sgml-mode.el
--- sgml-mode.el	18 Oct 2009 22:25:40 -0000	1.143
+++ sgml-mode.el	21 Oct 2009 23:02:02 -0000
@@ -1048,6 +1048,12 @@
                   (let ((cdata-start (point)))
                     (unless (search-forward "]]>" pos 'move)
                       (list 0 nil nil 'cdata nil nil nil nil cdata-start))))
+                 ((looking-at comment-start-skip)
+		  ;; parse-partial-sexp doesn't handle <!-- comments -->,
+		  ;; or only if ?- is in sgml-specials, so match explicitly
+                  (let ((start (point)))
+                    (unless (re-search-forward comment-end-skip pos 'move)
+                      (list 0 nil nil nil t nil nil nil start))))
                  ((and sgml-xml-mode (looking-at "<\\?"))
                   ;; Processing Instructions.
                   ;; In SGML, it's basically a normal tag of the form

In GNU Emacs 23.1.1 (i486-pc-linux-gnu, GTK+ Version 2.16.5)
 of 2009-09-14 on raven, modified by Debian
configured using `configure  '--build=i486-linux-gnu' '--host=i486-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var/lib' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs23:/etc/emacs:/usr/local/share/emacs/23.1/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.1/site-lisp:/usr/share/emacs/site-lisp:/usr/share/emacs/23.1/leim' '--with-x=yes' '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars' 'build_alias=i486-linux-gnu' 'host_alias=i486-linux-gnu' 'CFLAGS=-DDEBIAN -g -O2' 'LDFLAGS=-g' 'CPPFLAGS=''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: en_AU
  value of $XMODIFIERS: nil
  locale-coding-system: iso-latin-1-unix
  default-enable-multibyte-characters: t